<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 19/04/19
 * Time: 8.13
 */

namespace FiloBlu\DisableRmaPersonalizedOrder\Plugin;

use Magento\Framework\App\RequestInterface;
use Magento\Framework\Message\ManagerInterface;


class ShowCustomErrorMessageForRma
{
    protected $messageManager;
    protected $request;


    /**
     * ShowCustomErrorMessageForRma constructor.
     * @param ManagerInterface $messageManager
     * @param RequestInterface $request
     */
    public function __construct(ManagerInterface $messageManager,
                                RequestInterface $request)
    {

        $this->messageManager = $messageManager;
        $this->request = $request;

    }


    /**
     * @param \Magento\Rma\Controller\Returns\Create $subject
     */
    public function afterExecute(\Magento\Rma\Controller\Returns\Create $subject)
    {

        //check if it is a rma personalized order request
        $isPersonalized = $this->request->getParam('isPersonalized');
        //show error from plugin if any
        $pluginErrorMsg = $this->request->getParam('errorMessageFromPlugin');
        if(isset($pluginErrorMsg))
        {
            $this->messageManager->addErrorMessage($this->request->getParam('errorMessageFromPlugin'));
        }
        if($isPersonalized)
        {
            //show custom error message
            $this->messageManager->addErrorMessage("Rma not applicable on personalized orders. Try to remove personalized order from yuor RMA request.");

        }

    }

}